#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK1x76x76NT1x4x4_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=1, NB=76, KB=76, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=4, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + 2;
   const float *stN = B + 152;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 2 - (152*(lda)), incAn = -2;
   const int incBk = (((ldb) << 1)), incBm = -(152*(ldb));
   #define incBn 8
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 3)) - 2;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1, m2, m3, m4, m5, m6, m7;
   register float rC0_0, rC0_1, rC0_2, rC0_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      rC0_0 = rC0_1 = rC0_2 = rC0_3 = 0.0;
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rB2 = pB0[4];
      m1 = rA0 * rB1;
      rB3 = pB0[6];
      m2 = rA0 * rB2;
      m3 = rA0 * rB3;
      pA0 += incAk0;
      pB0 += incBk0;
      rA0 = *pA0;
      rB0 = *pB0;
      rB1 = pB0[2];
      rB2 = pB0[4];
      m4 = rA0 * rB0;
      rB3 = pB0[6];
      m5 = rA0 * rB1;
      m6 = rA0 * rB2;
      m7 = rA0 * rB3;
      pA0 += incAk0;
      pB0 += incBk0;
      rA0 = *pA0;
      rB0 = *pB0;
      rB1 = pB0[2];
      rB2 = pB0[4];

      for (k=72; k; k -= 4) /* easy loop to unroll */
      {
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rB3 = pB0[6];
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rB3 = pB0[6];
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rB3 = pB0[6];
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rB3 = pB0[6];
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
      } /* end K-loop */
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB3 = pB0[6];
      rC0_1 += m1;
      m1 = rA0 * rB1;
      rC0_2 += m2;
      m2 = rA0 * rB2;
      rC0_3 += m3;
      m3 = rA0 * rB3;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rB1 = pB0[2];
      rB2 = pB0[4];
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB3 = pB0[6];
      rC0_1 += m5;
      m5 = rA0 * rB1;
      rC0_2 += m6;
      m6 = rA0 * rB2;
      rC0_3 += m7;
      m7 = rA0 * rB3;
      pA0 += incAk0;
      pB0 += incBk0;
      rC0_0 += m0;
      rC0_1 += m1;
      rC0_2 += m2;
      rC0_3 += m3;
      rC0_0 += m4;
      rC0_1 += m5;
      rC0_2 += m6;
      rC0_3 += m7;
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC0_2 *= rB0;
      rC0_3 *= rB0;
      *pC0 = rC0_0;
      *pC1 = rC0_1;
      *pC2 = rC0_2;
      *pC3 = rC0_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK76x76x76NT0x0x0_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=76, NB=76, KB=76, 
 * lda=0, ldb=0, ldc=0, mu=3, nu=4, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 150;
   const float *stN = B + 152;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 6 - (152*(lda)), incAn = -150;
   const int incBk = (((ldb) << 1)), incBm = -(152*(ldb));
   #define incBn 8
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 6
   const int incCn = (((ldc) << 3)) - 150;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1, m2, m3, m4, m5, m6, m7;
   register float rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2, rC0_3, rC1_3, rC2_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = rC1_0 = rC2_0 = rC0_1 = rC1_1 = rC2_1 = rC0_2 = rC1_2 = rC2_2 = rC0_3 = rC1_3 = rC2_3 = 0.0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         m1 = rA1 * rB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         m2 = rA2 * rB0;
         rB3 = pB0[6];
         m3 = rA0 * rB1;
         m4 = rA1 * rB1;
         m5 = rA2 * rB1;
         m6 = rA0 * rB2;
         m7 = rA1 * rB2;

         for (k=72; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA2 * rB2;
            rC1_0 += m1;
            m1 = rA0 * rB3;
            rC2_0 += m2;
            m2 = rA1 * rB3;
            rC0_1 += m3;
            m3 = rA2 * rB3;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[2];
            rA2 = pA0[4];
            rC1_1 += m4;
            m4 = rA0 * rB0;
            rB1 = pB0[2];
            rB2 = pB0[4];
            rC2_1 += m5;
            m5 = rA1 * rB0;
            rB3 = pB0[6];
            rC0_2 += m6;
            m6 = rA2 * rB0;
            rC1_2 += m7;
            m7 = rA0 * rB1;
            rC2_2 += m0;
            m0 = rA1 * rB1;
            rC0_3 += m1;
            m1 = rA2 * rB1;
            rC1_3 += m2;
            m2 = rA0 * rB2;
            rC2_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA2 * rB2;
            rC1_0 += m5;
            m5 = rA0 * rB3;
            rC2_0 += m6;
            m6 = rA1 * rB3;
            rC0_1 += m7;
            m7 = rA2 * rB3;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[2];
            rA2 = pA0[4];
            rC1_1 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[2];
            rB2 = pB0[4];
            rC2_1 += m1;
            m1 = rA1 * rB0;
            rB3 = pB0[6];
            rC0_2 += m2;
            m2 = rA2 * rB0;
            rC1_2 += m3;
            m3 = rA0 * rB1;
            rC2_2 += m4;
            m4 = rA1 * rB1;
            rC0_3 += m5;
            m5 = rA2 * rB1;
            rC1_3 += m6;
            m6 = rA0 * rB2;
            rC2_3 += m7;
            m7 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA2 * rB2;
            rC1_0 += m1;
            m1 = rA0 * rB3;
            rC2_0 += m2;
            m2 = rA1 * rB3;
            rC0_1 += m3;
            m3 = rA2 * rB3;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[2];
            rA2 = pA0[4];
            rC1_1 += m4;
            m4 = rA0 * rB0;
            rB1 = pB0[2];
            rB2 = pB0[4];
            rC2_1 += m5;
            m5 = rA1 * rB0;
            rB3 = pB0[6];
            rC0_2 += m6;
            m6 = rA2 * rB0;
            rC1_2 += m7;
            m7 = rA0 * rB1;
            rC2_2 += m0;
            m0 = rA1 * rB1;
            rC0_3 += m1;
            m1 = rA2 * rB1;
            rC1_3 += m2;
            m2 = rA0 * rB2;
            rC2_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA2 * rB2;
            rC1_0 += m5;
            m5 = rA0 * rB3;
            rC2_0 += m6;
            m6 = rA1 * rB3;
            rC0_1 += m7;
            m7 = rA2 * rB3;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[2];
            rA2 = pA0[4];
            rC1_1 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[2];
            rB2 = pB0[4];
            rC2_1 += m1;
            m1 = rA1 * rB0;
            rB3 = pB0[6];
            rC0_2 += m2;
            m2 = rA2 * rB0;
            rC1_2 += m3;
            m3 = rA0 * rB1;
            rC2_2 += m4;
            m4 = rA1 * rB1;
            rC0_3 += m5;
            m5 = rA2 * rB1;
            rC1_3 += m6;
            m6 = rA0 * rB2;
            rC2_3 += m7;
            m7 = rA1 * rB2;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA2 * rB2;
         rC1_0 += m1;
         m1 = rA0 * rB3;
         rC2_0 += m2;
         m2 = rA1 * rB3;
         rC0_1 += m3;
         m3 = rA2 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_1 += m4;
         m4 = rA0 * rB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rC2_1 += m5;
         m5 = rA1 * rB0;
         rB3 = pB0[6];
         rC0_2 += m6;
         m6 = rA2 * rB0;
         rC1_2 += m7;
         m7 = rA0 * rB1;
         rC2_2 += m0;
         m0 = rA1 * rB1;
         rC0_3 += m1;
         m1 = rA2 * rB1;
         rC1_3 += m2;
         m2 = rA0 * rB2;
         rC2_3 += m3;
         m3 = rA1 * rB2;
         rC0_0 += m4;
         m4 = rA2 * rB2;
         rC1_0 += m5;
         m5 = rA0 * rB3;
         rC2_0 += m6;
         m6 = rA1 * rB3;
         rC0_1 += m7;
         m7 = rA2 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[6];
         rC0_2 += m2;
         m2 = rA2 * rB0;
         rC1_2 += m3;
         m3 = rA0 * rB1;
         rC2_2 += m4;
         m4 = rA1 * rB1;
         rC0_3 += m5;
         m5 = rA2 * rB1;
         rC1_3 += m6;
         m6 = rA0 * rB2;
         rC2_3 += m7;
         m7 = rA1 * rB2;
         rC0_0 += m0;
         m0 = rA2 * rB2;
         rC1_0 += m1;
         m1 = rA0 * rB3;
         rC2_0 += m2;
         m2 = rA1 * rB3;
         rC0_1 += m3;
         m3 = rA2 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_1 += m4;
         m4 = rA0 * rB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rC2_1 += m5;
         m5 = rA1 * rB0;
         rB3 = pB0[6];
         rC0_2 += m6;
         m6 = rA2 * rB0;
         rC1_2 += m7;
         m7 = rA0 * rB1;
         rC2_2 += m0;
         m0 = rA1 * rB1;
         rC0_3 += m1;
         m1 = rA2 * rB1;
         rC1_3 += m2;
         m2 = rA0 * rB2;
         rC2_3 += m3;
         m3 = rA1 * rB2;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m4;
         m4 = rA2 * rB2;
         rC1_0 += m5;
         m5 = rA0 * rB3;
         rC2_0 += m6;
         m6 = rA1 * rB3;
         rC0_1 += m7;
         m7 = rA2 * rB3;
         pA0 += incAk0;
         pB0 += incBk0;
         rC1_1 += m0;
         rC2_1 += m1;
         rC0_2 += m2;
         rC1_2 += m3;
         rC2_2 += m4;
         rC0_3 += m5;
         rC1_3 += m6;
         rC2_3 += m7;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC2_2 *= rB0;
         rC2_3 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC1[4] = rC2_1;
         *pC2 = rC0_2;
         pC2[2] = rC1_2;
         pC2[4] = rC2_2;
         *pC3 = rC0_3;
         pC3[2] = rC1_3;
         pC3[4] = rC2_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_cJIK1x76x76NT1x4x4_aX_b0(1, 76, 76, alpha, ca + 150, lda, cb, ldb, beta, cc + 150, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
