#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0TN1x1x1_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 1
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 1
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=K; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0TN1x1x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)>>2)<<2, kr = K - Kloop - 2;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 4
   const int incBm = -(Kb), incBn = (ldb);
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0;
   register float rC0_0;
   if (K < 3)
   {
      ATL_sJIK0x0x0TN1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];

         pA0 += (incAk0);
         pB0 += (incBk0);
         for (k=Kloop; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
         switch(kr)
         {
         case 1:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            pA0 += (incAk0);
            pB0 += (incBk0);
            break;
         case 2:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            pA0 += (((incAk0) << 1));
            pB0 += (((incBk0) << 1));
            break;
         case 3:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            pA0 += (((incAk0) << 1)+incAk0);
            pB0 += (((incBk0) << 1)+incBk0);
            break;
         case 0: ;
         }
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         pA0 += incAk0;
         pB0 += incBk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_sJIK0x0x0TN3x1x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=3, nu=1, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/3)*3;
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)>>2)<<2, kr = K - Kloop - 2;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((((lda) << 1)+lda) - Kb), incAn = -(Mb*lda);
   #define incBk 4
   const int incBm = -(Kb), incBn = (ldb);
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 3
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda);
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0;
   register float m0, m1, m2;
   register float rC0_0, rC1_0, rC2_0;
   if (K < 3)
   {
      ATL_sJIK0x0x0TN1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = *pA1;
            m0 = rA0 * rB0;
            rA2 = *pA2;
            m1 = rA1 * rB0;
            m2 = rA2 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA1[1];
            rA2 = pA2[1];

            pA0 += (incAk0);
            pA1 += (incAk0);
            pA2 += (incAk0);
            pB0 += (incBk0);
            for (k=Kloop; k; k -= 4) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pB0 += incBk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               pA0 += (incAk0);
               pA1 += (incAk0);
               pA2 += (incAk0);
               pB0 += (incBk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               pA0 += (((incAk0) << 1));
               pA1 += (((incAk0) << 1));
               pA2 += (((incAk0) << 1));
               pB0 += (((incBk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               pA0 += (((incAk0) << 1)+incAk0);
               pA1 += (((incAk0) << 1)+incAk0);
               pA2 += (((incAk0) << 1)+incAk0);
               pB0 += (((incBk0) << 1)+incBk0);
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC0_0 += m0;
            rC1_0 += m1;
            rC2_0 += m2;
            pA0 += incAk0;
            pA1 += incAk0;
            pA2 += incAk0;
            pB0 += incBk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x0TN1x1x4_aX_bX(k, N, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0TN1x4x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=4, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N>>2)<<2;
   #define Kb K
   const int Kloop = ((K-2)>>2)<<2, kr = K - Kloop - 2;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 4
   const int incBm = -(Kb), incBn = (((ldb) << 2));
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 1
   const int incCn = (((ldc) << 2)) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1, m2, m3;
   register float rC0_0, rC0_1, rC0_2, rC0_3;
   if (K < 3)
   {
      ATL_sJIK0x0x0TN1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = *pB1;
            m0 = rA0 * rB0;
            rB2 = *pB2;
            rB3 = *pB3;
            m1 = rA0 * rB1;
            m2 = rA0 * rB2;
            m3 = rA0 * rB3;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB1[1];
            rB2 = pB2[1];
            rB3 = pB3[1];

            pA0 += (incAk0);
            pB0 += (incBk0);
            pB1 += (incBk0);
            pB2 += (incBk0);
            pB3 += (incBk0);
            for (k=Kloop; k; k -= 4) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rB2 = pB2[1];
               rB3 = pB3[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rB3 = pB3[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rB2 = pB2[3];
               rB3 = pB3[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rB3 = pB3[4];
               pA0 += incAk;
               pB0 += incBk;
               pB1 += incBk;
               pB2 += incBk;
               pB3 += incBk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rB2 = pB2[1];
               rB3 = pB3[1];
               pA0 += (incAk0);
               pB0 += (incBk0);
               pB1 += (incBk0);
               pB2 += (incBk0);
               pB3 += (incBk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rB2 = pB2[1];
               rB3 = pB3[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rB3 = pB3[2];
               pA0 += (((incAk0) << 1));
               pB0 += (((incBk0) << 1));
               pB1 += (((incBk0) << 1));
               pB2 += (((incBk0) << 1));
               pB3 += (((incBk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rB2 = pB2[1];
               rB3 = pB3[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rB3 = pB3[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rB2 = pB2[3];
               rB3 = pB3[3];
               pA0 += (((incAk0) << 1)+incAk0);
               pB0 += (((incBk0) << 1)+incBk0);
               pB1 += (((incBk0) << 1)+incBk0);
               pB2 += (((incBk0) << 1)+incBk0);
               pB3 += (((incBk0) << 1)+incBk0);
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rC0_2 += m2;
            m2 = rA0 * rB2;
            rC0_3 += m3;
            m3 = rA0 * rB3;
            rC0_0 += m0;
            rC0_1 += m1;
            rC0_2 += m2;
            rC0_3 += m3;
            pA0 += incAk0;
            pB0 += incBk0;
            pB1 += incBk0;
            pB2 += incBk0;
            pB3 += incBk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC0_1 *= rB0;
            rC0_2 *= rB0;
            rC0_3 *= rB0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pA0 += incAm;
            pB0 += incBm;
            pB1 += incBm;
            pB2 += incBm;
            pB3 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pA0 += incAn;
         pB0 += incBn;
         pB1 += incBn;
         pB2 += incBn;
         pB3 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_sJIK0x0x0TN1x1x4_aX_bX(M, k, K, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x0TN0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=3, nu=4, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/3)*3;
   const int Nb = (N>>2)<<2;
   #define Kb K
   const int Kloop = ((K-1)>>2)<<2, kr = K - Kloop - 1;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((((lda) << 1)+lda) - Kb), incAn = -(Mb*lda);
   #define incBk 4
   const int incBm = -(Kb), incBn = (((ldb) << 2));
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 3
   const int incCn = (((ldc) << 2)) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda);
   const float *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register float rA0, rA1, rA2;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2, rC0_3, rC1_3, rC2_3;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            ATL_pfl1R(pfA+0);
            ATL_pfl1R(pfA+16);
            pfA += lda;
            do /* M-loop */
            {
               rA0 = BetaAlpha;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[1];
               rC1_0 *= rA0;
               rC2_0 = pC0[2];
               rC2_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[1];
               rC1_1 *= rA0;
               rC2_1 = pC1[2];
               rC2_1 *= rA0;
               rC0_2 = *pC2;
               rC0_2 *= rA0;
               rC1_2 = pC2[1];
               rC1_2 *= rA0;
               rC2_2 = pC2[2];
               rC2_2 *= rA0;
               rC0_3 = *pC3;
               rC0_3 *= rA0;
               rC1_3 = pC3[1];
               rC1_3 *= rA0;
               rC2_3 = pC3[2];
               rC2_3 *= rA0;
/*
 *             Start pipeline
 */
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               m0 = rA0 * rB0;
               rA2 = *pA2;
               rB1 = *pB1;
               rB2 = *pB2;
               m1 = rA1 * rB0;
               rB3 = *pB3;
               m2 = rA2 * rB0;
               m3 = rA0 * rB1;

               for (k=Kloop; k; k -= 4) /* easy loop to unroll */
               {
                  rC0_0 += m0;
                  m0 = rA1 * rB1;
                  rC1_0 += m1;
                  m1 = rA2 * rB1;
                  rC2_0 += m2;
                  m2 = rA0 * rB2;
                  rC0_1 += m3;
                  m3 = rA1 * rB2;
                  rC1_1 += m0;
                  m0 = rA2 * rB2;
                  rC2_1 += m1;
                  m1 = rA0 * rB3;
                  rC0_2 += m2;
                  m2 = rA1 * rB3;
                  rC1_2 += m3;
                  m3 = rA2 * rB3;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rB1 = pB1[1];
                  rB2 = pB2[1];
                  rC2_2 += m0;
                  m0 = rA0 * rB0;
                  rB3 = pB3[1];
                  rC0_3 += m1;
                  m1 = rA1 * rB0;
                  rC1_3 += m2;
                  m2 = rA2 * rB0;
                  rC2_3 += m3;
                  m3 = rA0 * rB1;
                  rC0_0 += m0;
                  m0 = rA1 * rB1;
                  rC1_0 += m1;
                  m1 = rA2 * rB1;
                  rC2_0 += m2;
                  m2 = rA0 * rB2;
                  rC0_1 += m3;
                  m3 = rA1 * rB2;
                  rC1_1 += m0;
                  m0 = rA2 * rB2;
                  rC2_1 += m1;
                  m1 = rA0 * rB3;
                  rC0_2 += m2;
                  m2 = rA1 * rB3;
                  rC1_2 += m3;
                  m3 = rA2 * rB3;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rB1 = pB1[2];
                  rB2 = pB2[2];
                  rC2_2 += m0;
                  m0 = rA0 * rB0;
                  rB3 = pB3[2];
                  rC0_3 += m1;
                  m1 = rA1 * rB0;
                  rC1_3 += m2;
                  m2 = rA2 * rB0;
                  rC2_3 += m3;
                  m3 = rA0 * rB1;
                  rC0_0 += m0;
                  m0 = rA1 * rB1;
                  rC1_0 += m1;
                  m1 = rA2 * rB1;
                  rC2_0 += m2;
                  m2 = rA0 * rB2;
                  rC0_1 += m3;
                  m3 = rA1 * rB2;
                  rC1_1 += m0;
                  m0 = rA2 * rB2;
                  rC2_1 += m1;
                  m1 = rA0 * rB3;
                  rC0_2 += m2;
                  m2 = rA1 * rB3;
                  rC1_2 += m3;
                  m3 = rA2 * rB3;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rB1 = pB1[3];
                  rB2 = pB2[3];
                  rC2_2 += m0;
                  m0 = rA0 * rB0;
                  rB3 = pB3[3];
                  rC0_3 += m1;
                  m1 = rA1 * rB0;
                  rC1_3 += m2;
                  m2 = rA2 * rB0;
                  rC2_3 += m3;
                  m3 = rA0 * rB1;
                  rC0_0 += m0;
                  m0 = rA1 * rB1;
                  rC1_0 += m1;
                  m1 = rA2 * rB1;
                  rC2_0 += m2;
                  m2 = rA0 * rB2;
                  rC0_1 += m3;
                  m3 = rA1 * rB2;
                  rC1_1 += m0;
                  m0 = rA2 * rB2;
                  rC2_1 += m1;
                  m1 = rA0 * rB3;
                  rC0_2 += m2;
                  m2 = rA1 * rB3;
                  rC1_2 += m3;
                  m3 = rA2 * rB3;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rB1 = pB1[4];
                  rB2 = pB2[4];
                  rC2_2 += m0;
                  m0 = rA0 * rB0;
                  rB3 = pB3[4];
                  rC0_3 += m1;
                  m1 = rA1 * rB0;
                  rC1_3 += m2;
                  m2 = rA2 * rB0;
                  rC2_3 += m3;
                  m3 = rA0 * rB1;
                  pA0 += incAk;
                  pA1 += incAk;
                  pA2 += incAk;
                  pB0 += incBk;
                  pB1 += incBk;
                  pB2 += incBk;
                  pB3 += incBk;
               } /* end K-loop */
               switch(kr)
               {
               case 1:
                  rC0_0 += m0;
                  m0 = rA1 * rB1;
                  rC1_0 += m1;
                  m1 = rA2 * rB1;
                  rC2_0 += m2;
                  m2 = rA0 * rB2;
                  rC0_1 += m3;
                  m3 = rA1 * rB2;
                  rC1_1 += m0;
                  m0 = rA2 * rB2;
                  rC2_1 += m1;
                  m1 = rA0 * rB3;
                  rC0_2 += m2;
                  m2 = rA1 * rB3;
                  rC1_2 += m3;
                  m3 = rA2 * rB3;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rB1 = pB1[1];
                  rB2 = pB2[1];
                  rC2_2 += m0;
                  m0 = rA0 * rB0;
                  rB3 = pB3[1];
                  rC0_3 += m1;
                  m1 = rA1 * rB0;
                  rC1_3 += m2;
                  m2 = rA2 * rB0;
                  rC2_3 += m3;
                  m3 = rA0 * rB1;
                  pA0 += (incAk0);
                  pA1 += (incAk0);
                  pA2 += (incAk0);
                  pB0 += (incBk0);
                  pB1 += (incBk0);
                  pB2 += (incBk0);
                  pB3 += (incBk0);
                  break;
               case 2:
                  rC0_0 += m0;
                  m0 = rA1 * rB1;
                  rC1_0 += m1;
                  m1 = rA2 * rB1;
                  rC2_0 += m2;
                  m2 = rA0 * rB2;
                  rC0_1 += m3;
                  m3 = rA1 * rB2;
                  rC1_1 += m0;
                  m0 = rA2 * rB2;
                  rC2_1 += m1;
                  m1 = rA0 * rB3;
                  rC0_2 += m2;
                  m2 = rA1 * rB3;
                  rC1_2 += m3;
                  m3 = rA2 * rB3;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rB1 = pB1[1];
                  rB2 = pB2[1];
                  rC2_2 += m0;
                  m0 = rA0 * rB0;
                  rB3 = pB3[1];
                  rC0_3 += m1;
                  m1 = rA1 * rB0;
                  rC1_3 += m2;
                  m2 = rA2 * rB0;
                  rC2_3 += m3;
                  m3 = rA0 * rB1;
                  rC0_0 += m0;
                  m0 = rA1 * rB1;
                  rC1_0 += m1;
                  m1 = rA2 * rB1;
                  rC2_0 += m2;
                  m2 = rA0 * rB2;
                  rC0_1 += m3;
                  m3 = rA1 * rB2;
                  rC1_1 += m0;
                  m0 = rA2 * rB2;
                  rC2_1 += m1;
                  m1 = rA0 * rB3;
                  rC0_2 += m2;
                  m2 = rA1 * rB3;
                  rC1_2 += m3;
                  m3 = rA2 * rB3;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rB1 = pB1[2];
                  rB2 = pB2[2];
                  rC2_2 += m0;
                  m0 = rA0 * rB0;
                  rB3 = pB3[2];
                  rC0_3 += m1;
                  m1 = rA1 * rB0;
                  rC1_3 += m2;
                  m2 = rA2 * rB0;
                  rC2_3 += m3;
                  m3 = rA0 * rB1;
                  pA0 += (((incAk0) << 1));
                  pA1 += (((incAk0) << 1));
                  pA2 += (((incAk0) << 1));
                  pB0 += (((incBk0) << 1));
                  pB1 += (((incBk0) << 1));
                  pB2 += (((incBk0) << 1));
                  pB3 += (((incBk0) << 1));
                  break;
               case 3:
                  rC0_0 += m0;
                  m0 = rA1 * rB1;
                  rC1_0 += m1;
                  m1 = rA2 * rB1;
                  rC2_0 += m2;
                  m2 = rA0 * rB2;
                  rC0_1 += m3;
                  m3 = rA1 * rB2;
                  rC1_1 += m0;
                  m0 = rA2 * rB2;
                  rC2_1 += m1;
                  m1 = rA0 * rB3;
                  rC0_2 += m2;
                  m2 = rA1 * rB3;
                  rC1_2 += m3;
                  m3 = rA2 * rB3;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rB1 = pB1[1];
                  rB2 = pB2[1];
                  rC2_2 += m0;
                  m0 = rA0 * rB0;
                  rB3 = pB3[1];
                  rC0_3 += m1;
                  m1 = rA1 * rB0;
                  rC1_3 += m2;
                  m2 = rA2 * rB0;
                  rC2_3 += m3;
                  m3 = rA0 * rB1;
                  rC0_0 += m0;
                  m0 = rA1 * rB1;
                  rC1_0 += m1;
                  m1 = rA2 * rB1;
                  rC2_0 += m2;
                  m2 = rA0 * rB2;
                  rC0_1 += m3;
                  m3 = rA1 * rB2;
                  rC1_1 += m0;
                  m0 = rA2 * rB2;
                  rC2_1 += m1;
                  m1 = rA0 * rB3;
                  rC0_2 += m2;
                  m2 = rA1 * rB3;
                  rC1_2 += m3;
                  m3 = rA2 * rB3;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rB1 = pB1[2];
                  rB2 = pB2[2];
                  rC2_2 += m0;
                  m0 = rA0 * rB0;
                  rB3 = pB3[2];
                  rC0_3 += m1;
                  m1 = rA1 * rB0;
                  rC1_3 += m2;
                  m2 = rA2 * rB0;
                  rC2_3 += m3;
                  m3 = rA0 * rB1;
                  rC0_0 += m0;
                  m0 = rA1 * rB1;
                  rC1_0 += m1;
                  m1 = rA2 * rB1;
                  rC2_0 += m2;
                  m2 = rA0 * rB2;
                  rC0_1 += m3;
                  m3 = rA1 * rB2;
                  rC1_1 += m0;
                  m0 = rA2 * rB2;
                  rC2_1 += m1;
                  m1 = rA0 * rB3;
                  rC0_2 += m2;
                  m2 = rA1 * rB3;
                  rC1_2 += m3;
                  m3 = rA2 * rB3;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rB1 = pB1[3];
                  rB2 = pB2[3];
                  rC2_2 += m0;
                  m0 = rA0 * rB0;
                  rB3 = pB3[3];
                  rC0_3 += m1;
                  m1 = rA1 * rB0;
                  rC1_3 += m2;
                  m2 = rA2 * rB0;
                  rC2_3 += m3;
                  m3 = rA0 * rB1;
                  pA0 += (((incAk0) << 1)+incAk0);
                  pA1 += (((incAk0) << 1)+incAk0);
                  pA2 += (((incAk0) << 1)+incAk0);
                  pB0 += (((incBk0) << 1)+incBk0);
                  pB1 += (((incBk0) << 1)+incBk0);
                  pB2 += (((incBk0) << 1)+incBk0);
                  pB3 += (((incBk0) << 1)+incBk0);
                  break;
               case 0: ;
               }
/*
 *             Drain pipe on last iteration of K-loop
 */
               rC0_0 += m0;
               m0 = rA1 * rB1;
               rC1_0 += m1;
               m1 = rA2 * rB1;
               rC2_0 += m2;
               m2 = rA0 * rB2;
               rC0_1 += m3;
               m3 = rA1 * rB2;
               rC1_1 += m0;
               m0 = rA2 * rB2;
               rC2_1 += m1;
               m1 = rA0 * rB3;
               rC0_2 += m2;
               m2 = rA1 * rB3;
               rC1_2 += m3;
               m3 = rA2 * rB3;
               rC2_2 += m0;
               rC0_3 += m1;
               rC1_3 += m2;
               rC2_3 += m3;
               pA0 += incAk0;
               pA1 += incAk0;
               pA2 += incAk0;
               pB0 += incBk0;
               pB1 += incBk0;
               pB2 += incBk0;
               pB3 += incBk0;
               rB0 = alpha;
               rC0_0 *= rB0;
               rC0_1 *= rB0;
               rC0_2 *= rB0;
               rC0_3 *= rB0;
               rC1_0 *= rB0;
               rC1_1 *= rB0;
               rC1_2 *= rB0;
               rC1_3 *= rB0;
               rC2_0 *= rB0;
               rC2_1 *= rB0;
               rC2_2 *= rB0;
               rC2_3 *= rB0;
               *pC0 = rC0_0;
               pC0[1] = rC1_0;
               pC0[2] = rC2_0;
               *pC1 = rC0_1;
               pC1[1] = rC1_1;
               pC1[2] = rC2_1;
               *pC2 = rC0_2;
               pC2[1] = rC1_2;
               pC2[2] = rC2_2;
               *pC3 = rC0_3;
               pC3[1] = rC1_3;
               pC3[2] = rC2_3;
               pC0 += incCm;
               pC1 += incCm;
               pC2 += incCm;
               pC3 += incCm;
               pA0 += incAm;
               pA1 += incAm;
               pA2 += incAm;
               pB0 += incBm;
               pB1 += incBm;
               pB2 += incBm;
               pB3 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pC2 += incCn;
            pC3 += incCn;
            pA0 += incAn;
            pA1 += incAn;
            pA2 += incAn;
            pB0 += incBn;
            pB1 += incBn;
            pB2 += incBn;
            pB3 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_sJIK0x0x0TN3x1x4_aX_bX(M, k, K, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb && (k=M-Mb))
      ATL_sJIK0x0x0TN1x4x4_aX_bX(k, Nb, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
