#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK1x76x76TN1x4x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=1, NB=76, KB=76, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=4, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + (lda);
   const float *stN = B + (76*(ldb));
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((lda) - 76), incAn = -(lda);
   #define incBk 4
   const int incBm = -76, incBn = (((ldb) << 2));
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 1
   const int incCn = (((ldc) << 2)) - 1;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1, m2, m3, m4, m5, m6, m7;
   register float rC0_0, rC0_1, rC0_2, rC0_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      rA0 = BetaAlpha;
      rC0_0 = *pC0;
      rC0_0 *= rA0;
      rC0_1 = *pC1;
      rC0_1 *= rA0;
      rC0_2 = *pC2;
      rC0_2 *= rA0;
      rC0_3 = *pC3;
      rC0_3 *= rA0;
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rB1 = *pB1;
      m0 = rA0 * rB0;
      rB2 = *pB2;
      rB3 = *pB3;
      m1 = rA0 * rB1;
      m2 = rA0 * rB2;
      m3 = rA0 * rB3;
      rA0 = pA0[1];
      rB0 = pB0[1];
      rB1 = pB1[1];
      rB2 = pB2[1];
      rB3 = pB3[1];
      m4 = rA0 * rB0;
      m5 = rA0 * rB1;
      m6 = rA0 * rB2;
      m7 = rA0 * rB3;
      rA0 = pA0[2];
      rB0 = pB0[2];
      rB1 = pB1[2];
      rB2 = pB2[2];
      rB3 = pB3[2];

      pA0 += (((incAk0) << 1));
      pB0 += (((incBk0) << 1));
      pB1 += (((incBk0) << 1));
      pB2 += (((incBk0) << 1));
      pB3 += (((incBk0) << 1));
      for (k=72; k; k -= 4) /* easy loop to unroll */
      {
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB1[1];
         rB2 = pB2[1];
         rB3 = pB3[1];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rB3 = pB3[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB1[3];
         rB2 = pB2[3];
         rB3 = pB3[3];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB1[4];
         rB2 = pB2[4];
         rB3 = pB3[4];
         pA0 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
      } /* end K-loop */
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rC0_1 += m1;
      m1 = rA0 * rB1;
      rC0_2 += m2;
      m2 = rA0 * rB2;
      rC0_3 += m3;
      m3 = rA0 * rB3;
      rA0 = pA0[1];
      rB0 = pB0[1];
      rB1 = pB1[1];
      rB2 = pB2[1];
      rB3 = pB3[1];
      pA0 += (incAk0);
      pB0 += (incBk0);
      pB1 += (incBk0);
      pB2 += (incBk0);
      pB3 += (incBk0);
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rC0_1 += m5;
      m5 = rA0 * rB1;
      rC0_2 += m6;
      m6 = rA0 * rB2;
      rC0_3 += m7;
      m7 = rA0 * rB3;
      rC0_0 += m0;
      rC0_1 += m1;
      rC0_2 += m2;
      rC0_3 += m3;
      rC0_0 += m4;
      rC0_1 += m5;
      rC0_2 += m6;
      rC0_3 += m7;
      pA0 += incAk0;
      pB0 += incBk0;
      pB1 += incBk0;
      pB2 += incBk0;
      pB3 += incBk0;
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC0_2 *= rB0;
      rC0_3 *= rB0;
      *pC0 = rC0_0;
      *pC1 = rC0_1;
      *pC2 = rC0_2;
      *pC3 = rC0_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pB2 += incBm;
      pB3 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK76x76x76TN0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=76, NB=76, KB=76, 
 * lda=0, ldb=0, ldc=0, mu=3, nu=4, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (75*(lda));
   const float *stN = B + (76*(ldb));
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((((lda) << 1)+lda) - 76), incAn = -(75*(lda));
   #define incBk 4
   const int incBm = -76, incBn = (((ldb) << 2));
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 3
   const int incCn = (((ldc) << 2)) - 75;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda);
   const float *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register float rA0, rA1, rA2;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1, m2, m3, m4, m5;
   register float rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2, rC0_3, rC1_3, rC2_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC2_0 = pC0[2];
         rC2_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[1];
         rC1_1 *= rA0;
         rC2_1 = pC1[2];
         rC2_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC1_2 = pC2[1];
         rC1_2 *= rA0;
         rC2_2 = pC2[2];
         rC2_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC1_3 = pC3[1];
         rC1_3 *= rA0;
         rC2_3 = pC3[2];
         rC2_3 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         m0 = rA0 * rB0;
         rA2 = *pA2;
         rB1 = *pB1;
         rB2 = *pB2;
         m1 = rA1 * rB0;
         rB3 = *pB3;
         m2 = rA2 * rB0;
         m3 = rA0 * rB1;
         m4 = rA1 * rB1;
         m5 = rA2 * rB1;

         for (k=72; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC0_1 += m3;
            m3 = rA0 * rB3;
            rC1_1 += m4;
            m4 = rA1 * rB3;
            rC2_1 += m5;
            m5 = rA2 * rB3;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA1[1];
            rA2 = pA2[1];
            rB1 = pB1[1];
            rB2 = pB2[1];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rB3 = pB3[1];
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC0_3 += m3;
            m3 = rA0 * rB1;
            rC1_3 += m4;
            m4 = rA1 * rB1;
            rC2_3 += m5;
            m5 = rA2 * rB1;
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC0_1 += m3;
            m3 = rA0 * rB3;
            rC1_1 += m4;
            m4 = rA1 * rB3;
            rC2_1 += m5;
            m5 = rA2 * rB3;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA1[2];
            rA2 = pA2[2];
            rB1 = pB1[2];
            rB2 = pB2[2];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rB3 = pB3[2];
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC0_3 += m3;
            m3 = rA0 * rB1;
            rC1_3 += m4;
            m4 = rA1 * rB1;
            rC2_3 += m5;
            m5 = rA2 * rB1;
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC0_1 += m3;
            m3 = rA0 * rB3;
            rC1_1 += m4;
            m4 = rA1 * rB3;
            rC2_1 += m5;
            m5 = rA2 * rB3;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA1[3];
            rA2 = pA2[3];
            rB1 = pB1[3];
            rB2 = pB2[3];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rB3 = pB3[3];
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC0_3 += m3;
            m3 = rA0 * rB1;
            rC1_3 += m4;
            m4 = rA1 * rB1;
            rC2_3 += m5;
            m5 = rA2 * rB1;
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC0_1 += m3;
            m3 = rA0 * rB3;
            rC1_1 += m4;
            m4 = rA1 * rB3;
            rC2_1 += m5;
            m5 = rA2 * rB3;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA1[4];
            rA2 = pA2[4];
            rB1 = pB1[4];
            rB2 = pB2[4];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rB3 = pB3[4];
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC0_3 += m3;
            m3 = rA0 * rB1;
            rC1_3 += m4;
            m4 = rA1 * rB1;
            rC2_3 += m5;
            m5 = rA2 * rB1;
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC0_1 += m3;
         m3 = rA0 * rB3;
         rC1_1 += m4;
         m4 = rA1 * rB3;
         rC2_1 += m5;
         m5 = rA2 * rB3;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA1[1];
         rA2 = pA2[1];
         rB1 = pB1[1];
         rB2 = pB2[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB3 = pB3[1];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC0_3 += m3;
         m3 = rA0 * rB1;
         rC1_3 += m4;
         m4 = rA1 * rB1;
         rC2_3 += m5;
         m5 = rA2 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC0_1 += m3;
         m3 = rA0 * rB3;
         rC1_1 += m4;
         m4 = rA1 * rB3;
         rC2_1 += m5;
         m5 = rA2 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA1[2];
         rA2 = pA2[2];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB3 = pB3[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC0_3 += m3;
         m3 = rA0 * rB1;
         rC1_3 += m4;
         m4 = rA1 * rB1;
         rC2_3 += m5;
         m5 = rA2 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC0_1 += m3;
         m3 = rA0 * rB3;
         rC1_1 += m4;
         m4 = rA1 * rB3;
         rC2_1 += m5;
         m5 = rA2 * rB3;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA1[3];
         rA2 = pA2[3];
         rB1 = pB1[3];
         rB2 = pB2[3];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB3 = pB3[3];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rC2_2 += m2;
         m2 = rA2 * rB0;
         rC0_3 += m3;
         m3 = rA0 * rB1;
         rC1_3 += m4;
         m4 = rA1 * rB1;
         rC2_3 += m5;
         m5 = rA2 * rB1;
         pA0 += (((incAk0) << 1)+incAk0);
         pA1 += (((incAk0) << 1)+incAk0);
         pA2 += (((incAk0) << 1)+incAk0);
         pB0 += (((incBk0) << 1)+incBk0);
         pB1 += (((incBk0) << 1)+incBk0);
         pB2 += (((incBk0) << 1)+incBk0);
         pB3 += (((incBk0) << 1)+incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC2_0 += m2;
         m2 = rA2 * rB2;
         rC0_1 += m3;
         m3 = rA0 * rB3;
         rC1_1 += m4;
         m4 = rA1 * rB3;
         rC2_1 += m5;
         m5 = rA2 * rB3;
         rC0_2 += m0;
         rC1_2 += m1;
         rC2_2 += m2;
         rC0_3 += m3;
         rC1_3 += m4;
         rC2_3 += m5;
         pA0 += incAk0;
         pA1 += incAk0;
         pA2 += incAk0;
         pB0 += incBk0;
         pB1 += incBk0;
         pB2 += incBk0;
         pB3 += incBk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC2_2 *= rB0;
         rC2_3 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
   ATL_sJIK1x76x76TN1x4x4_aX_bX(1, 76, 76, alpha, ca + (75*(lda)), lda, cb, ldb, beta, cc + 75, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
